<template>
    <section>
        <h2 class="pb-2">Create Ad</h2>

        <form class="pr-lg-5">
            <div class="row">
                <div class="col-12 col-lg-9">

                    <div class="form-group">
                        <label for="nameInput">Campaign Name</label>
                        <input type="text" v-model="name" v-bind:class="['form-control',  {'is-invalid' : validationError && validationError.name}]" id="nameInput" placeholder="Eg: Beer Promo">

                        <template v-if="validationError && validationError.name">
                            <span class="invalid-feedback">
                                <strong>{{ validationError.name[0] }}</strong>
                            </span>
                        </template>
                    </div>

                    <div class="form-group">
                        <label for="genderInput">Target Gender</label>

                        <div id="genderInput" v-bind:class="['row',  {'is-invalid' : validationError && validationError.gender}]">

                            <div class="col-md-4 pr-0 mb-2">
                                <div v-bind:class="['card', 'select-gender-card',  {'active' : maleSelected }]" v-on:click.prevent="genderSelected('male')">
                                    <div class="card-body p-2">
                                        Male  <span class="float-right" v-if="maleSelected"><i class="fas fa-check"></i></span>
                                    </div>
                                </div>
                            </div>

                            <div class="col-md-4 pr-0 mb-2">
                                <div v-bind:class="['card', 'select-gender-card',  {'active' : femaleSelected }]" v-on:click.prevent="genderSelected('female')">
                                    <div class="card-body p-2">
                                        Female  <span class="float-right" v-if="femaleSelected"><i class="fas fa-check"></i></span>
                                    </div>
                                </div>
                            </div>

                        </div>

                        <template v-if="validationError && validationError.gender">
                            <span class="text-small text-danger">
                                <strong>{{ validationError.gender[0] }}</strong>
                            </span>
                        </template>
                    </div>

                    <div class="form-group">
                        <label for="ageRangeInput">Target Age Range</label>

                        <div class="row mx-0" id="ageRangeInput">

                            <input type="number" class="form-control col-md-4" min="18" max="100" v-model="ageRangeMin" placeholder="From" required>

                            <input type="number" class="form-control col-md-4 ml-3" min="19" max="100" v-model="ageRangeMax" placeholder="To" required>


                        </div>

                        <template v-if="validationError && (validationError.age_range_min || validationError.age_range_max)">
                            <span class="text-small text-danger">
                                <strong>{{ validationError.age_range_min ? validationError.age_range_min[0] : validationError.age_range_max[0] }}</strong>
                            </span>
                        </template>
                    </div>

                    <div class="form-group">
                        <label for="categorySelect">Ad Type</label>
                        <select id="categorySelect" v-bind:class="['form-control',  {'is-invalid' : validationError && validationError.type}]" v-model="type">
                            <option value="text">Text</option>
                            <option value="image">Image</option>
                        </select>

                        <template v-if="validationError && validationError.type">
                            <span class="invalid-feedback">
                                <strong>{{ validationError.type[0] }}</strong>
                            </span>
                        </template>
                    </div>

                </div>

                <hr class="col-12">

                <template v-if="type">

                    <h4 class="col-12">Design Ad</h4>

                    <div class="col-12 col-md-6" style="min-height: 3rem;">

                        <template v-if="type === 'text'">

                            <div class="form-group">
                                <label for="destinationUrl">Destination URL</label>
                                <input type="text" v-model="destinationUrl" v-bind:class="['form-control',  {'is-invalid' : validationError && validationError.destination_url}]" id="destinationUrl" placeholder="Eg: https://google.com/">

                                <template v-if="validationError && validationError.destination_url">
                            <span class="invalid-feedback">
                                <strong>{{ validationError.destination_url[0] }}</strong>
                            </span>
                                </template>
                            </div>

                            <div class="form-group">
                                <label for="headline">Headline</label>
                                <input type="text" v-model="headline" v-bind:class="['form-control',  {'is-invalid' : validationError && validationError.headline}]" id="headline" placeholder="">

                                <template v-if="validationError && validationError.headline">
                            <span class="invalid-feedback">
                                <strong>{{ validationError.headline[0] }}</strong>
                            </span>
                                </template>
                            </div>

                            <div class="form-group">
                                <label for="adTextLineOne">Ad Text Line 1</label>
                                <input type="text" v-model="adTextLineOne" v-bind:class="['form-control',  {'is-invalid' : validationError && validationError.ad_text_line_one}]" id="adTextLineOne" placeholder="">

                                <template v-if="validationError && validationError.ad_text_line_one">
                            <span class="invalid-feedback">
                                <strong>{{ validationError.ad_text_line_one[0] }}</strong>
                            </span>
                                </template>
                            </div>

                            <div class="form-group">
                                <label for="adTextLineTwo">Ad Text Line 2</label>
                                <input type="text" v-model="adTextLineTwo" v-bind:class="['form-control',  {'is-invalid' : validationError && validationError.ad_text_line_two}]" id="adTextLineTwo" placeholder="">

                                <template v-if="validationError && validationError.ad_text_line_two">
                            <span class="invalid-feedback">
                                <strong>{{ validationError.ad_text_line_two[0] }}</strong>
                            </span>
                                </template>
                            </div>

                            <div class="form-group">
                                <label for="actionText">Action Text</label>
                                <input type="text" v-model="actionText" v-bind:class="['form-control',  {'is-invalid' : validationError && validationError.action_text}]" id="actionText" placeholder="">

                                <template v-if="validationError && validationError.action_text">
                            <span class="invalid-feedback">
                                <strong>{{ validationError.action_text[0] }}</strong>
                            </span>
                                </template>
                            </div>

                        </template>

                        <template v-if="type === 'image'">

                            <div class="form-group">
                                <label for="destinationUrl2">Destination URL</label>
                                <input type="text" v-model="destinationUrl" v-bind:class="['form-control',  {'is-invalid' : validationError && validationError.destination_url}]" id="destinationUrl2" placeholder="Eg: https://google.com/">

                                <template v-if="validationError && validationError.destination_url">
                            <span class="invalid-feedback">
                                <strong>{{ validationError.destination_url[0] }}</strong>
                            </span>
                                </template>
                            </div>

                            <div class="form-group">
                                <label>Upload Image</label>
                                <div class="custom-file">
                                    <input type="file" class="custom-file-input" id="customFile" @change="onFileChange">
                                    <label class="custom-file-label" for="customFile">Choose file</label>
                                </div>

                                <span class="d-block text-small text-danger pt-2" v-if="!isValidImageSize && image">Unsupported Image Size</span>
                            </div>

                            <div class="form-group">
                                <label>Accepted Images</label>

                                <div class="row mx-auto">

                                    <div class="col-4 p-1">
                                        <div v-bind:class="['card', 'accepted-image-card', {'active' : images.a320x50} ]">
                                            <div class="card-body">
                                                <span class="d-block text-center">320 x 50</span>
                                            </div>
                                        </div>
                                    </div>

                                    <div class="col-4 p-1">
                                        <div v-bind:class="['card', 'accepted-image-card', {'active' : images.a320x100} ]">
                                            <div class="card-body">
                                                <span class="d-block text-center">320 x 100</span>
                                            </div>
                                        </div>
                                    </div>

                                    <div class="col-4 p-1">
                                        <div v-bind:class="['card', 'accepted-image-card', {'active' : images.a728x90} ]">
                                            <div class="card-body">
                                                <span class="d-block text-center">728 x 90</span>
                                            </div>
                                        </div>
                                    </div>

                                    <div class="col-4 p-1">
                                        <div v-bind:class="['card', 'accepted-image-card', {'active' : images.a336x280} ]">
                                            <div class="card-body">
                                                <span class="d-block text-center">336 x 280</span>
                                            </div>
                                        </div>
                                    </div>

                                    <div class="col-4 p-1">
                                        <div v-bind:class="['card', 'accepted-image-card', {'active' : images.a300x250} ]">
                                            <div class="card-body">
                                                <span class="d-block text-center">300 x 250</span>
                                            </div>
                                        </div>
                                    </div>

                                    <div class="col-4 p-1">
                                        <div v-bind:class="['card', 'accepted-image-card', {'active' : images.a300x600} ]">
                                            <div class="card-body">
                                                <span class="d-block text-center">300 x 600</span>
                                            </div>
                                        </div>
                                    </div>


                                </div>
                            </div>

                        </template>


                    </div>

                    <div class="col-12 col-md-6"  style="min-height: 3rem;">

                        <div class="form-group" v-if="textAdPreviewAvailable">
                            <label for="adPreviewSize">Ad preview Size</label>
                            <select id="adPreviewSize" v-bind:class="['form-control',  {'is-invalid' : validationError && validationError.type}]" v-model="previewSize">
                                <option value="320x50" selected>320 x 50</option>
                                <option value="320x100">320 x 100</option>
                                <option value="728x90">728 x 90</option>
                                <option value="336x280">336 x 280</option>
                                <option value="300x250">300 x 250</option>
                                <option value="300x600">300 x 600</option>
                            </select>

                            <template v-if="validationError && validationError.type">
                            <span class="invalid-feedback">
                                <strong>{{ validationError.type[0] }}</strong>
                            </span>
                            </template>
                        </div>

                        <div class="d-flex justify-content-center">
                            <div class="border rounded text-center m-2 p-3 d-flex justify-content-center" style="height: 24rem; width: 24rem;">
                                <img v-bind:src="image" alt="" v-if="image && type === 'image' && isValidImageSize" style="object-fit: contain;">
                                <iframe class="align-self-center" v-bind:width="previewWidth" v-bind:height="previewHeight"  scrolling="no" style="border: 0;" v-bind:src="previewUrl" v-else-if="isPreviewing && textAdPreviewAvailable"></iframe>
                                <span class="align-self-center font-weight-bold h5 mb-0" v-else>Ad Preview</span>
                            </div>
                        </div>

                        <div class="d-flex justify-content-center" v-if="image && type === 'image' && isValidImageSize"><a href="#" class="btn btn-outline-primary text-center font-weight-bold" v-on:click.prevent="addToAcceptedImages">ADD IMAGE</a></div>

                        <div class="d-flex justify-content-center" v-if="textAdPreviewAvailable"><a href="#" class="btn btn-outline-primary text-center font-weight-bold" v-on:click.prevent="loadPreview">Load Preview Preview</a></div>

                    </div>

                    <div class="form-group">
                        <button type="submit" class="btn btn-primary" v-on:click.prevent="createAd" v-if="!loading">CREATE</button>
                        <button type="submit" class="btn btn-primary" v-else disabled><i class="fas fa-spinner fa-spin"></i> CREATE</button>
                    </div>

                </template>

                <template v-else>
                    <div class="alert alert-warning col-12 col-lg-9">
                        Select a type to continue.
                    </div>
                </template>

                <div class="alert alert-success col-12" v-if="success">
                    {{ success.message }} <router-link v-bind:to="'/advertiser/my-ads/' + createdAd.id" v-if="createdAd">Go to Ad.</router-link>
                    <button type="button" class="close" v-on:click.prevent="success = '';" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>

                <div class="alert alert-danger col-12" v-if="fail">
                    {{ fail.message }}
                    <button type="button" class="close" v-on:click.prevent="fail = '';" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>



            </div>
        </form>


    </section>
</template>

<script>
    export default {
        data: function () {
            return {
                name: '',
                ageRangeMin: '',
                ageRangeMax: '',
                type: '',

                destinationUrl: '',
                headline: '',
                adTextLineOne: '',
                adTextLineTwo: '',
                actionText: '',

                // Selected Gender
                maleSelected: false,
                femaleSelected: false,

                image: '',
                imageFile: null,
                imageAttributes: '',
                isValidImageSize: false,

                // Approved Images
                images: {
                    'a320x50': '',
                    'a320x100': '',
                    'a728x90': '',
                    'a336x280': '',
                    'a300x250': '',
                    'a300x600': '',
                },

                // iframe properties
                previewUrl: '',
                previewWidth: 0,
                previewHeight: 0,
                isPreviewing: false,
                previewSize: '320x50',

                // Created Ad
                createdAd: null,

                // Validation Error
                validationError: '',

                // Loading Flag
                loading: false,

                // Success Flag
                success: '',

                // Fail Flag
                fail: '',

            }
        },
        methods: {
            createAd: function() {
                // Show the loading
                this.loading = true;

                // Clear previous status flags
                this.fail = false;
                this.success = false;
                this.validationError = false;

                let formData = new FormData();

                formData.append('name', this.name);
                formData.append('gender', this.gender);
                formData.append('age_range_min' , this.ageRangeMin);
                formData.append('age_range_max' , this.ageRangeMax);
                formData.append('type' , this.type);

                formData.append('destination_url' , this.destinationUrl);
                formData.append('headline' , this.headline);
                formData.append('ad_text_line_one' , this.adTextLineOne);
                formData.append('ad_text_line_two' , this.adTextLineTwo);
                formData.append('action_text' , this.actionText);

                // Image Data
                formData.append('image_one' , this.images.a320x50);
                formData.append('image_two' , this.images.a320x100);
                formData.append('image_three' , this.images.a728x90);
                formData.append('image_four' , this.images.a336x280);
                formData.append('image_five' , this.images.a300x250);
                formData.append('image_six' , this.images.a300x600);

                // Make the request to server
                axios.post('/api/advertiser/ads/new', formData, { headers: { 'Content-Type' : 'multipart/form-data' }})
                    .then(response => {
                        this.success = {
                            'message' : 'Ad Created.'
                        };

                        // Set the created ad
                        this.createdAd = response.data.ad;

                        // Clear Previous Inputs
                        this.name= '';
                        this.ageRangeMin= '';
                        this.ageRangeMax= '';
                        this.type= '';

                        this.destinationUrl= '';
                        this.headline= '';
                        this.adTextLineOne= '';
                        this.adTextLineTwo= '';
                        this.actionText= '';

                    })
                    .catch(error => {
                        if (error.response) {
                            // The request was made and the server responded with a status code
                            // that falls out of the range of 2xx
                            console.log(error.response.status);

                            // Handle validation errors
                            if (error.response.status === 422) {
                                this.validationError = error.response.data.errors;
                            } else {
                                this.fail = {
                                    message: error.response.stats + ' Something went wrong.'
                                };
                            }

                        } else if (error.request) {
                            // The request was made, but no response was received
                            console.log(error.request);

                            this.fail = {
                                message: 'Check your connection and try again.'
                            };

                        } else {
                            // Something happened in setting up the request that triggered an error
                            console.log('Error', error.message);

                            this.fail = {
                                message: 'Something went wrong. Check the log.'
                            };
                        }
                    })
                    .then(e => {
                        // Hide the loading
                        this.loading = false;
                    });
            },
            genderSelected: function(gender) {
                if (gender === 'female') {
                    this.femaleSelected = !this.femaleSelected;
                } else {
                    this.maleSelected = !this.maleSelected;
                }
            },
            onFileChange(e) {
                let files = e.target.files || e.dataTransfer.files;
                if (!files.length)
                    return;
                this.createImage(files[0]);
            },
            createImage(file) {
                let reader = new FileReader();
                let vm = this;

                this.imageFile = file;

                reader.onload = (e) => {
                    vm.image = e.target.result;

                    let image = new Image();
                    image.src = e.target.result;

                    image.onload = function() {
                        // access image size here
                        console.log(this.width);
                        vm.imageAttributes = {
                            width: this.width,
                            height: this.height
                        };

                    };
                };
                reader.readAsDataURL(file);
            },
            addToAcceptedImages: function () {
                if (this.image && this.isValidImageSize) {
                    // Build the size string
                    let sizeString = this.imageAttributes.width + 'x' + this.imageAttributes.height;
                    switch (sizeString) {
                        case '320x50':
                            this.images["a320x50"] = this.imageFile;
                            break;
                        case '320x100':
                            this.images["a320x100"] = this.imageFile;
                            break;
                        case '728x90':
                            this.images["a728x90"] = this.imageFile;
                            break;
                        case '336x280':
                            this.images["a336x280"] = this.imageFile;
                            break;
                        case '300x250':
                            this.images["a300x250"] = this.imageFile;
                            break;
                        case '300x600':
                            this.images["a300x600"] = this.imageFile;
                            break;
                    }

                    // Clear image
                    this.image = null;
                }
            },
            loadPreview: function () {
                // Build the url
                this.previewUrl = '/ads/preview/text?headline=' + this.headline +
                    '&ad_text_line_one=' + this.adTextLineOne +
                    '&ad_text_line_two=' + this.adTextLineTwo +
                    '&action_text=' + this.actionText +
                    '&destination_url=' + this.destinationUrl +
                    '&size=' + this.previewSize;

                let size = this.previewSize.split("x", 2);

                // Set the size
                this.previewWidth = parseInt(size[0]) + 5;
                this.previewHeight = parseInt(size[1]) + 5;

                // Set the previewing flag
                this.isPreviewing = true;
            }
        },
        computed: {
            gender: function() {
                if (this.maleSelected && this.femaleSelected) {
                    return 'both';
                } else if (!this.maleSelected && !this.femaleSelected) {
                    return null;
                } else if (this.maleSelected) {
                    return 'male';
                } else {
                    return 'female';
                }
            },
            textAdPreviewAvailable: function () {
                return (this.type === 'text' && this.destinationUrl &&
                    this.headline && this.adTextLineOne &&
                    this.adTextLineTwo && this.actionText) ? true : false;

            }
        },
        watch: {
            imageAttributes: function() {
                if (this.imageAttributes && this.imageAttributes.width && this.imageAttributes.height) {
                    // Check image size
                    let width = this.imageAttributes.width;
                    let height = this.imageAttributes.height;

                    this.isValidImageSize = (width === 320 && height === 50) || // Mobile Banner
                        (width === 320 && height === 100) || // Large Mobile Banner
                        (width === 728 && height === 90) || // Leader Board
                        (width === 336 && height === 280) || // Large Rectangle
                        (width === 300 && height === 250) || // Medium Rectangle
                        (width === 300 && height === 600);

                } else {
                    this.isValidImageSize = false;
                }
            }
        },
        mounted() {
            console.log('Advertiser - Create Ad mounted.')
        }
    }
</script>

<style scoped>

    .select-gender-card {
        z-index: 2;
        cursor: pointer;
    }

    .select-gender-card:hover, .select-gender-card.active {
        color: #fff;
        background: #3490dc !important;
    }

    .accepted-image-card {
        z-index: 2;
        cursor: pointer;
        color: #a7a7a7;
    }

    .accepted-image-card.active {
        color: #fff !important;
        background: #3490dc !important;
    }

</style>
